This documentation is automatically generated by online-judge-tools/verification-helper
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#include "my_template.hpp"
#include "alg/monoid/add.hpp"
#include "mod/modint.hpp"
#include "ds/randomized_bst/rbst_commutative_monoid.hpp"
#include "random/base.hpp"
using mint = modint998;
void test() {
using Mono = Monoid_Add<int>;
RBST_CommutativeMonoid<Mono, true> X(10000);
using np = decltype(X)::np;
FOR(1000) {
X.reset();
int N = RNG(1, 20);
int Q = RNG(1, 1000);
vvc<int> AA(1);
FOR(i, N) AA[0].eb(RNG(0, 100));
vc<np> roots = {X.new_node(AA[0])};
FOR(Q) {
vc<int> cand = {0, 1, 2, 3, 4, 5};
int t = cand[RNG(0, len(cand))];
int frm = RNG(0, len(AA));
vc<int> A = AA[frm];
np root = roots[frm];
if (t == 0) {
int i = RNG(0, N);
assert(A[i] == X.get(root, i));
}
if (t == 1) {
int i = RNG(0, N);
int x = RNG(0, 100);
root = X.set(root, i, x);
A[i] = x;
}
if (t == 2) {
int i = RNG(0, N);
int x = RNG(0, 100);
root = X.multiply(root, i, x);
A[i] = Mono::op(A[i], x);
}
if (t == 3) {
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R) == SUM<int>(B));
}
if (t == 4) {
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
root = X.reverse(root, L, R);
reverse(A.begin() + L, A.begin() + R);
}
if (t == 5) {
vc<int> B = X.get_all(root);
assert(A == B);
}
AA.eb(A);
roots.eb(root);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}
#line 1 "test/1_mytest/rbst_commutative_persistent.test.cpp"
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#line 1 "my_template.hpp"
#if defined(LOCAL)
#include <my_template_compiled.hpp>
#else
// https://codeforces.com/blog/entry/96344
#pragma GCC optimize("Ofast,unroll-loops")
// いまの CF だとこれ入れると動かない?
// #pragma GCC target("avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;
using i128 = __int128;
using u128 = unsigned __int128;
using f128 = __float128;
template <class T>
constexpr T infty = 0;
template <>
constexpr int infty<int> = 1'010'000'000;
template <>
constexpr ll infty<ll> = 2'020'000'000'000'000'000;
template <>
constexpr u32 infty<u32> = infty<int>;
template <>
constexpr u64 infty<u64> = infty<ll>;
template <>
constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000;
template <>
constexpr double infty<double> = infty<ll>;
template <>
constexpr long double infty<long double> = infty<ll>;
using pi = pair<ll, ll>;
using vi = vector<ll>;
template <class T>
using vc = vector<T>;
template <class T>
using vvc = vector<vc<T>>;
template <class T>
using vvvc = vector<vvc<T>>;
template <class T>
using vvvvc = vector<vvvc<T>>;
template <class T>
using vvvvvc = vector<vvvvc<T>>;
template <class T>
using pq = priority_queue<T>;
template <class T>
using pqg = priority_queue<T, vector<T>, greater<T>>;
#define vv(type, name, h, ...) vector<vector<type>> name(h, vector<type>(__VA_ARGS__))
#define vvv(type, name, h, w, ...) vector<vector<vector<type>>> name(h, vector<vector<type>>(w, vector<type>(__VA_ARGS__)))
#define vvvv(type, name, a, b, c, ...) \
vector<vector<vector<vector<type>>>> name(a, vector<vector<vector<type>>>(b, vector<vector<type>>(c, vector<type>(__VA_ARGS__))))
// https://trap.jp/post/1224/
#define FOR1(a) for (ll _ = 0; _ < ll(a); ++_)
#define FOR2(i, a) for (ll i = 0; i < ll(a); ++i)
#define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i)
#define FOR4(i, a, b, c) for (ll i = a; i < ll(b); i += (c))
#define FOR1_R(a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR2_R(i, a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR3_R(i, a, b) for (ll i = (b)-1; i >= ll(a); --i)
#define overload4(a, b, c, d, e, ...) e
#define overload3(a, b, c, d, ...) d
#define FOR(...) overload4(__VA_ARGS__, FOR4, FOR3, FOR2, FOR1)(__VA_ARGS__)
#define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__)
#define all(x) x.begin(), x.end()
#define len(x) ll(x.size())
#define elif else if
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define stoi stoll
int popcnt(int x) { return __builtin_popcount(x); }
int popcnt(u32 x) { return __builtin_popcount(x); }
int popcnt(ll x) { return __builtin_popcountll(x); }
int popcnt(u64 x) { return __builtin_popcountll(x); }
int popcnt_sgn(int x) { return (__builtin_parity(unsigned(x)) & 1 ? -1 : 1); }
int popcnt_sgn(u32 x) { return (__builtin_parity(x) & 1 ? -1 : 1); }
int popcnt_sgn(ll x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
int popcnt_sgn(u64 x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2)
int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2)
int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
template <typename T>
T kth_bit(int k) {
return T(1) << k;
}
template <typename T>
bool has_kth_bit(T x, int k) {
return x >> k & 1;
}
template <typename UINT>
struct all_bit {
struct iter {
UINT s;
iter(UINT s) : s(s) {}
int operator*() const { return lowbit(s); }
iter &operator++() {
s &= s - 1;
return *this;
}
bool operator!=(const iter) const { return s != 0; }
};
UINT s;
all_bit(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename UINT>
struct all_subset {
static_assert(is_unsigned<UINT>::value);
struct iter {
UINT s, t;
bool ed;
iter(UINT s) : s(s), t(s), ed(0) {}
int operator*() const { return s ^ t; }
iter &operator++() {
(t == 0 ? ed = 1 : t = (t - 1) & s);
return *this;
}
bool operator!=(const iter) const { return !ed; }
};
UINT s;
all_subset(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename T>
T floor(T a, T b) {
return a / b - (a % b && (a ^ b) < 0);
}
template <typename T>
T ceil(T x, T y) {
return floor(x + y - 1, y);
}
template <typename T>
T bmod(T x, T y) {
return x - y * floor(x, y);
}
template <typename T>
pair<T, T> divmod(T x, T y) {
T q = floor(x, y);
return {q, x - q * y};
}
template <typename T, typename U>
T SUM(const vector<U> &A) {
T sm = 0;
for (auto &&a: A) sm += a;
return sm;
}
#define MIN(v) *min_element(all(v))
#define MAX(v) *max_element(all(v))
#define LB(c, x) distance((c).begin(), lower_bound(all(c), (x)))
#define UB(c, x) distance((c).begin(), upper_bound(all(c), (x)))
#define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end()), x.shrink_to_fit()
template <typename T>
T POP(deque<T> &que) {
T a = que.front();
que.pop_front();
return a;
}
template <typename T>
T POP(pq<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(pqg<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(vc<T> &que) {
T a = que.back();
que.pop_back();
return a;
}
template <typename F>
ll binary_search(F check, ll ok, ll ng, bool check_ok = true) {
if (check_ok) assert(check(ok));
while (abs(ok - ng) > 1) {
auto x = (ng + ok) / 2;
(check(x) ? ok : ng) = x;
}
return ok;
}
template <typename F>
double binary_search_real(F check, double ok, double ng, int iter = 100) {
FOR(iter) {
double x = (ok + ng) / 2;
(check(x) ? ok : ng) = x;
}
return (ok + ng) / 2;
}
template <class T, class S>
inline bool chmax(T &a, const S &b) {
return (a < b ? a = b, 1 : 0);
}
template <class T, class S>
inline bool chmin(T &a, const S &b) {
return (a > b ? a = b, 1 : 0);
}
// ? は -1
vc<int> s_to_vi(const string &S, char first_char) {
vc<int> A(S.size());
FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); }
return A;
}
template <typename T, typename U>
vector<T> cumsum(vector<U> &A, int off = 1) {
int N = A.size();
vector<T> B(N + 1);
FOR(i, N) { B[i + 1] = B[i] + A[i]; }
if (off == 0) B.erase(B.begin());
return B;
}
// stable sort
template <typename T>
vector<int> argsort(const vector<T> &A) {
vector<int> ids(len(A));
iota(all(ids), 0);
sort(all(ids), [&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); });
return ids;
}
// A[I[0]], A[I[1]], ...
template <typename T>
vc<T> rearrange(const vc<T> &A, const vc<int> &I) {
vc<T> B(len(I));
FOR(i, len(I)) B[i] = A[I[i]];
return B;
}
template <typename T, typename... Vectors>
void concat(vc<T> &first, const Vectors &... others) {
vc<T> &res = first;
(res.insert(res.end(), others.begin(), others.end()), ...);
}
#endif
#line 2 "alg/monoid/add.hpp"
template <typename E>
struct Monoid_Add {
using X = E;
using value_type = X;
static constexpr X op(const X &x, const X &y) noexcept { return x + y; }
static constexpr X inverse(const X &x) noexcept { return -x; }
static constexpr X power(const X &x, ll n) noexcept { return X(n) * x; }
static constexpr X unit() { return X(0); }
static constexpr bool commute = true;
};
#line 2 "mod/modint_common.hpp"
struct has_mod_impl {
template <class T>
static auto check(T &&x) -> decltype(x.get_mod(), std::true_type{});
template <class T>
static auto check(...) -> std::false_type;
};
template <class T>
class has_mod : public decltype(has_mod_impl::check<T>(std::declval<T>())) {};
template <typename mint>
mint inv(int n) {
static const int mod = mint::get_mod();
static vector<mint> dat = {0, 1};
assert(0 <= n);
if (n >= mod) n %= mod;
while (len(dat) <= n) {
int k = len(dat);
int q = (mod + k - 1) / k;
dat.eb(dat[k * q - mod] * mint::raw(q));
}
return dat[n];
}
template <typename mint>
mint fact(int n) {
static const int mod = mint::get_mod();
assert(0 <= n && n < mod);
static vector<mint> dat = {1, 1};
while (len(dat) <= n) dat.eb(dat[len(dat) - 1] * mint::raw(len(dat)));
return dat[n];
}
template <typename mint>
mint fact_inv(int n) {
static vector<mint> dat = {1, 1};
if (n < 0) return mint(0);
while (len(dat) <= n) dat.eb(dat[len(dat) - 1] * inv<mint>(len(dat)));
return dat[n];
}
template <class mint, class... Ts>
mint fact_invs(Ts... xs) {
return (mint(1) * ... * fact_inv<mint>(xs));
}
template <typename mint, class Head, class... Tail>
mint multinomial(Head &&head, Tail &&... tail) {
return fact<mint>(head) * fact_invs<mint>(std::forward<Tail>(tail)...);
}
template <typename mint>
mint C_dense(int n, int k) {
assert(n >= 0);
if (k < 0 || n < k) return 0;
static vvc<mint> C;
static int H = 0, W = 0;
auto calc = [&](int i, int j) -> mint {
if (i == 0) return (j == 0 ? mint(1) : mint(0));
return C[i - 1][j] + (j ? C[i - 1][j - 1] : 0);
};
if (W <= k) {
FOR(i, H) {
C[i].resize(k + 1);
FOR(j, W, k + 1) { C[i][j] = calc(i, j); }
}
W = k + 1;
}
if (H <= n) {
C.resize(n + 1);
FOR(i, H, n + 1) {
C[i].resize(W);
FOR(j, W) { C[i][j] = calc(i, j); }
}
H = n + 1;
}
return C[n][k];
}
template <typename mint, bool large = false, bool dense = false>
mint C(ll n, ll k) {
assert(n >= 0);
if (k < 0 || n < k) return 0;
if constexpr (dense) return C_dense<mint>(n, k);
if constexpr (!large) return multinomial<mint>(n, k, n - k);
k = min(k, n - k);
mint x(1);
FOR(i, k) x *= mint(n - i);
return x * fact_inv<mint>(k);
}
template <typename mint, bool large = false>
mint C_inv(ll n, ll k) {
assert(n >= 0);
assert(0 <= k && k <= n);
if (!large) return fact_inv<mint>(n) * fact<mint>(k) * fact<mint>(n - k);
return mint(1) / C<mint, 1>(n, k);
}
// [x^d](1-x)^{-n}
template <typename mint, bool large = false, bool dense = false>
mint C_negative(ll n, ll d) {
assert(n >= 0);
if (d < 0) return mint(0);
if (n == 0) { return (d == 0 ? mint(1) : mint(0)); }
return C<mint, large, dense>(n + d - 1, d);
}
#line 3 "mod/modint.hpp"
template <int mod>
struct modint {
static constexpr u32 umod = u32(mod);
static_assert(umod < u32(1) << 31);
u32 val;
static modint raw(u32 v) {
modint x;
x.val = v;
return x;
}
constexpr modint() : val(0) {}
constexpr modint(u32 x) : val(x % umod) {}
constexpr modint(u64 x) : val(x % umod) {}
constexpr modint(u128 x) : val(x % umod) {}
constexpr modint(int x) : val((x %= mod) < 0 ? x + mod : x){};
constexpr modint(ll x) : val((x %= mod) < 0 ? x + mod : x){};
constexpr modint(i128 x) : val((x %= mod) < 0 ? x + mod : x){};
bool operator<(const modint &other) const { return val < other.val; }
modint &operator+=(const modint &p) {
if ((val += p.val) >= umod) val -= umod;
return *this;
}
modint &operator-=(const modint &p) {
if ((val += umod - p.val) >= umod) val -= umod;
return *this;
}
modint &operator*=(const modint &p) {
val = u64(val) * p.val % umod;
return *this;
}
modint &operator/=(const modint &p) {
*this *= p.inverse();
return *this;
}
modint operator-() const { return modint::raw(val ? mod - val : u32(0)); }
modint operator+(const modint &p) const { return modint(*this) += p; }
modint operator-(const modint &p) const { return modint(*this) -= p; }
modint operator*(const modint &p) const { return modint(*this) *= p; }
modint operator/(const modint &p) const { return modint(*this) /= p; }
bool operator==(const modint &p) const { return val == p.val; }
bool operator!=(const modint &p) const { return val != p.val; }
modint inverse() const {
int a = val, b = mod, u = 1, v = 0, t;
while (b > 0) {
t = a / b;
swap(a -= t * b, b), swap(u -= t * v, v);
}
return modint(u);
}
modint pow(ll n) const {
assert(n >= 0);
modint ret(1), mul(val);
while (n > 0) {
if (n & 1) ret *= mul;
mul *= mul;
n >>= 1;
}
return ret;
}
static constexpr int get_mod() { return mod; }
// (n, r), r は 1 の 2^n 乗根
static constexpr pair<int, int> ntt_info() {
if (mod == 120586241) return {20, 74066978};
if (mod == 167772161) return {25, 17};
if (mod == 469762049) return {26, 30};
if (mod == 754974721) return {24, 362};
if (mod == 880803841) return {23, 211};
if (mod == 943718401) return {22, 663003469};
if (mod == 998244353) return {23, 31};
if (mod == 1004535809) return {21, 582313106};
if (mod == 1012924417) return {21, 368093570};
return {-1, -1};
}
static constexpr bool can_ntt() { return ntt_info().fi != -1; }
};
#ifdef FASTIO
template <int mod>
void rd(modint<mod> &x) {
fastio::rd(x.val);
x.val %= mod;
// assert(0 <= x.val && x.val < mod);
}
template <int mod>
void wt(modint<mod> x) {
fastio::wt(x.val);
}
#endif
using modint107 = modint<1000000007>;
using modint998 = modint<998244353>;
#line 1 "ds/randomized_bst/rbst_commutative_monoid.hpp"
template <typename CommutativeMonoid, bool PERSISTENT>
struct RBST_CommutativeMonoid {
using Monoid = CommutativeMonoid;
using X = typename Monoid::value_type;
static_assert(Monoid::commute);
struct Node {
Node *l, *r;
X x, prod; // rev 反映済
u32 size;
bool rev;
};
const int NODES;
Node *pool;
int pid;
using np = Node *;
RBST_CommutativeMonoid(int NODES) : NODES(NODES), pid(0) { pool = new Node[NODES]; }
~RBST_CommutativeMonoid() { delete[] pool; }
void reset() { pid = 0; }
np new_node(const X &x) {
pool[pid].l = pool[pid].r = nullptr;
pool[pid].x = x;
pool[pid].prod = x;
pool[pid].size = 1;
pool[pid].rev = 0;
return &(pool[pid++]);
}
np new_node(const vc<X> &dat) {
auto dfs = [&](auto &dfs, u32 l, u32 r) -> np {
if (l == r) return nullptr;
if (r == l + 1) return new_node(dat[l]);
u32 m = (l + r) / 2;
np l_root = dfs(dfs, l, m);
np r_root = dfs(dfs, m + 1, r);
np root = new_node(dat[m]);
root->l = l_root, root->r = r_root;
update(root);
return root;
};
return dfs(dfs, 0, len(dat));
}
np copy_node(np &n) {
if (!n || !PERSISTENT) return n;
pool[pid].l = n->l, pool[pid].r = n->r;
pool[pid].x = n->x;
pool[pid].prod = n->prod;
pool[pid].size = n->size;
pool[pid].rev = n->rev;
return &(pool[pid++]);
}
np merge(np l_root, np r_root) { return merge_rec(l_root, r_root); }
np merge3(np a, np b, np c) { return merge(merge(a, b), c); }
np merge4(np a, np b, np c, np d) { return merge(merge(merge(a, b), c), d); }
pair<np, np> split(np root, u32 k) {
if (!root) {
assert(k == 0);
return {nullptr, nullptr};
}
assert(0 <= k && k <= root->size);
return split_rec(root, k);
}
tuple<np, np, np> split3(np root, u32 l, u32 r) {
np nm, nr;
tie(root, nr) = split(root, r);
tie(root, nm) = split(root, l);
return {root, nm, nr};
}
tuple<np, np, np, np> split4(np root, u32 i, u32 j, u32 k) {
np d;
tie(root, d) = split(root, k);
auto [a, b, c] = split3(root, i, j);
return {a, b, c, d};
}
X prod(np root, u32 l, u32 r) {
if (l == r) return Monoid::unit();
return prod_rec(root, l, r, false);
}
X prod(np root) { return (root ? root->prod : Monoid::unit()); }
np reverse(np root, u32 l, u32 r) {
assert(0 <= l && l <= r && r <= root->size);
if (r - l <= 1) return root;
auto [nl, nm, nr] = split3(root, l, r);
nm->rev ^= 1;
swap(nm->l, nm->r);
return merge3(nl, nm, nr);
}
np set(np root, u32 k, const X &x) { return set_rec(root, k, x); }
np multiply(np root, u32 k, const X &x) { return multiply_rec(root, k, x); }
X get(np root, u32 k) { return get_rec(root, k, false); }
vc<X> get_all(np root) {
vc<X> res;
auto dfs = [&](auto &dfs, np root, bool rev) -> void {
if (!root) return;
dfs(dfs, (rev ? root->r : root->l), rev ^ root->rev);
res.eb(root->x);
dfs(dfs, (rev ? root->l : root->r), rev ^ root->rev);
};
dfs(dfs, root, 0);
return res;
}
template <typename F>
pair<np, np> split_max_right(np root, const F check) {
assert(check(Monoid::unit()));
X x = Monoid::unit();
return split_max_right_rec(root, check, x);
}
private:
inline u32 xor128() {
static u32 x = 123456789;
static u32 y = 362436069;
static u32 z = 521288629;
static u32 w = 88675123;
u32 t = x ^ (x << 11);
x = y;
y = z;
z = w;
return w = (w ^ (w >> 19)) ^ (t ^ (t >> 8));
}
void prop(np c) {
// 自身をコピーする必要はない。
// 子をコピーする必要がある。複数の親を持つ可能性があるため。
if (c->rev) {
if (c->l) {
c->l = copy_node(c->l);
c->l->rev ^= 1;
swap(c->l->l, c->l->r);
}
if (c->r) {
c->r = copy_node(c->r);
c->r->rev ^= 1;
swap(c->r->l, c->r->r);
}
c->rev = 0;
}
}
void update(np c) {
// データを保ったまま正常化するだけなので、コピー不要
c->size = 1;
c->prod = c->x;
if (c->l) {
c->size += c->l->size;
c->prod = Monoid::op(c->l->prod, c->prod);
}
if (c->r) {
c->size += c->r->size;
c->prod = Monoid::op(c->prod, c->r->prod);
}
}
np merge_rec(np l_root, np r_root) {
if (!l_root) return r_root;
if (!r_root) return l_root;
u32 sl = l_root->size, sr = r_root->size;
if (xor128() % (sl + sr) < sl) {
prop(l_root);
l_root = copy_node(l_root);
l_root->r = merge_rec(l_root->r, r_root);
update(l_root);
return l_root;
}
prop(r_root);
r_root = copy_node(r_root);
r_root->l = merge_rec(l_root, r_root->l);
update(r_root);
return r_root;
}
pair<np, np> split_rec(np root, u32 k) {
if (!root) return {nullptr, nullptr};
prop(root);
u32 sl = (root->l ? root->l->size : 0);
if (k <= sl) {
auto [nl, nr] = split_rec(root->l, k);
root = copy_node(root);
root->l = nr;
update(root);
return {nl, root};
}
auto [nl, nr] = split_rec(root->r, k - (1 + sl));
root = copy_node(root);
root->r = nl;
update(root);
return {root, nr};
}
np set_rec(np root, u32 k, const X &x) {
if (!root) return root;
prop(root);
u32 sl = (root->l ? root->l->size : 0);
if (k < sl) {
root = copy_node(root);
root->l = set_rec(root->l, k, x);
update(root);
return root;
}
if (k == sl) {
root = copy_node(root);
root->x = x;
update(root);
return root;
}
root = copy_node(root);
root->r = set_rec(root->r, k - (1 + sl), x);
update(root);
return root;
}
np multiply_rec(np root, u32 k, const X &x) {
if (!root) return root;
prop(root);
u32 sl = (root->l ? root->l->size : 0);
if (k < sl) {
root = copy_node(root);
root->l = multiply_rec(root->l, k, x);
update(root);
return root;
}
if (k == sl) {
root = copy_node(root);
root->x = Monoid::op(root->x, x);
update(root);
return root;
}
root = copy_node(root);
root->r = multiply_rec(root->r, k - (1 + sl), x);
update(root);
return root;
}
X prod_rec(np root, u32 l, u32 r, bool rev) {
if (l == 0 && r == root->size) return root->prod;
np left = (rev ? root->r : root->l);
np right = (rev ? root->l : root->r);
u32 sl = (left ? left->size : 0);
X res = Monoid::unit();
if (l < sl) {
X y = prod_rec(left, l, min(r, sl), rev ^ root->rev);
res = Monoid::op(res, y);
}
if (l <= sl && sl < r) res = Monoid::op(res, root->x);
u32 k = 1 + sl;
if (k < r) {
X y = prod_rec(right, max(k, l) - k, r - k, rev ^ root->rev);
res = Monoid::op(res, y);
}
return res;
}
X get_rec(np root, u32 k, bool rev) {
np left = (rev ? root->r : root->l);
np right = (rev ? root->l : root->r);
u32 sl = (left ? left->size : 0);
if (k == sl) return root->x;
rev ^= root->rev;
if (k < sl) return get_rec(left, k, rev);
return get_rec(right, k - (1 + sl), rev);
}
template <typename F>
pair<np, np> split_max_right_rec(np root, const F &check, X &x) {
if (!root) return {nullptr, nullptr};
prop(root);
root = copy_node(root);
X y = Monoid::op(x, root->prod);
if (check(y)) {
x = y;
return {root, nullptr};
}
np left = root->l, right = root->r;
if (left) {
X y = Monoid::op(x, root->l->prod);
if (!check(y)) {
auto [n1, n2] = split_max_right_rec(left, check, x);
root->l = n2;
update(root);
return {n1, root};
}
x = y;
}
y = Monoid::op(x, root->x);
if (!check(y)) {
root->l = nullptr;
update(root);
return {left, root};
}
x = y;
auto [n1, n2] = split_max_right_rec(right, check, x);
root->r = n1;
update(root);
return {root, n2};
}
};
#line 2 "random/base.hpp"
u64 RNG_64() {
static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL;
x_ ^= x_ << 7;
return x_ ^= x_ >> 9;
}
u64 RNG(u64 lim) { return RNG_64() % lim; }
ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); }
#line 7 "test/1_mytest/rbst_commutative_persistent.test.cpp"
using mint = modint998;
void test() {
using Mono = Monoid_Add<int>;
RBST_CommutativeMonoid<Mono, true> X(10000);
using np = decltype(X)::np;
FOR(1000) {
X.reset();
int N = RNG(1, 20);
int Q = RNG(1, 1000);
vvc<int> AA(1);
FOR(i, N) AA[0].eb(RNG(0, 100));
vc<np> roots = {X.new_node(AA[0])};
FOR(Q) {
vc<int> cand = {0, 1, 2, 3, 4, 5};
int t = cand[RNG(0, len(cand))];
int frm = RNG(0, len(AA));
vc<int> A = AA[frm];
np root = roots[frm];
if (t == 0) {
int i = RNG(0, N);
assert(A[i] == X.get(root, i));
}
if (t == 1) {
int i = RNG(0, N);
int x = RNG(0, 100);
root = X.set(root, i, x);
A[i] = x;
}
if (t == 2) {
int i = RNG(0, N);
int x = RNG(0, 100);
root = X.multiply(root, i, x);
A[i] = Mono::op(A[i], x);
}
if (t == 3) {
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
vc<int> B = {A.begin() + L, A.begin() + R};
assert(X.prod(root, L, R) == SUM<int>(B));
}
if (t == 4) {
int L = RNG(0, N);
int R = RNG(0, N);
if (L > R) swap(L, R);
++R;
root = X.reverse(root, L, R);
reverse(A.begin() + L, A.begin() + R);
}
if (t == 5) {
vc<int> B = X.get_all(root);
assert(A == B);
}
AA.eb(A);
roots.eb(root);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}